Index: cpukit/score/include/rtems/linkersets.h
===================================================================
--- cpukit/score/include/rtems/linkersets.h	(revision 501b11baab8ba574d582662a5b97c1e3d296e59d)
+++ cpukit/score/include/rtems/linkersets.h	(revision 5fe6d07ad5690e3d9c6445ca3a465a700a5a5015)
@@ -58,4 +58,8 @@
   RTEMS_SECTION( ".rtemsroset." #set ".content.1" ) RTEMS_USED
 
+#define RTEMS_LINKER_ROSET_CONTENT( set, decl ) \
+  decl \
+  RTEMS_SECTION( ".rtemsroset." #set ".content" )
+
 #define RTEMS_LINKER_RWSET_DECLARE( set, type ) \
   extern type volatile RTEMS_LINKER_SET_BEGIN( set )[0]; \
@@ -90,4 +94,8 @@
   RTEMS_SECTION( ".rtemsrwset." #set ".content.1" ) RTEMS_USED
 
+#define RTEMS_LINKER_RWSET_CONTENT( set, decl ) \
+  decl \
+  RTEMS_SECTION( ".rtemsrwset." #set ".content" )
+
 #ifdef __cplusplus
 }
Index: testsuites/sptests/splinkersets01/init.c
===================================================================
--- testsuites/sptests/splinkersets01/init.c	(revision 501b11baab8ba574d582662a5b97c1e3d296e59d)
+++ testsuites/sptests/splinkersets01/init.c	(revision 5fe6d07ad5690e3d9c6445ca3a465a700a5a5015)
@@ -131,4 +131,27 @@
 }
 
+static void test_content(void)
+{
+  void volatile *b_rw = RTEMS_LINKER_SET_BEGIN(test_content_rw);
+  void volatile *e_rw = RTEMS_LINKER_SET_END(test_content_rw);
+
+  void volatile const *b_ro = RTEMS_LINKER_SET_BEGIN(test_content_ro);
+  void volatile const *e_ro = RTEMS_LINKER_SET_END(test_content_ro);
+
+  rtems_test_assert(&content_rw_1 >= b_rw);
+  rtems_test_assert(&content_rw_2 >= b_rw);
+  rtems_test_assert(&content_rw_3 >= b_rw);
+  rtems_test_assert(&content_rw_1 <= e_rw);
+  rtems_test_assert(&content_rw_2 <= e_rw);
+  rtems_test_assert(&content_rw_3 <= e_rw);
+
+  rtems_test_assert(&content_ro_1 >= b_ro);
+  rtems_test_assert(&content_ro_2 >= b_ro);
+  rtems_test_assert(&content_ro_3 >= b_ro);
+  rtems_test_assert(&content_ro_1 <= e_ro);
+  rtems_test_assert(&content_ro_2 <= e_ro);
+  rtems_test_assert(&content_ro_3 <= e_ro);
+}
+
 static void Init(rtems_task_argument arg)
 {
@@ -136,4 +159,5 @@
 
   test();
+  test_content();
 
   TEST_END();
Index: testsuites/sptests/splinkersets01/items.c
===================================================================
--- testsuites/sptests/splinkersets01/items.c	(revision 501b11baab8ba574d582662a5b97c1e3d296e59d)
+++ testsuites/sptests/splinkersets01/items.c	(revision 5fe6d07ad5690e3d9c6445ca3a465a700a5a5015)
@@ -22,2 +22,10 @@
 
 RTEMS_LINKER_ROSET_ITEM_ORDERED(test_ro, const int *, ca2, OC) = &ca[2];
+
+int content_rw_1;
+char content_rw_2;
+char content_rw_3;
+
+const int content_ro_1;
+const char content_ro_2;
+const char content_ro_3;
Index: testsuites/sptests/splinkersets01/sets.c
===================================================================
--- testsuites/sptests/splinkersets01/sets.c	(revision 501b11baab8ba574d582662a5b97c1e3d296e59d)
+++ testsuites/sptests/splinkersets01/sets.c	(revision 5fe6d07ad5690e3d9c6445ca3a465a700a5a5015)
@@ -22,2 +22,6 @@
 
 RTEMS_LINKER_ROSET(test_ro, const int *);
+
+RTEMS_LINKER_RWSET(test_content_rw, char);
+
+RTEMS_LINKER_ROSET(test_content_ro, char);
Index: testsuites/sptests/splinkersets01/splinkersets01.h
===================================================================
--- testsuites/sptests/splinkersets01/splinkersets01.h	(revision 501b11baab8ba574d582662a5b97c1e3d296e59d)
+++ testsuites/sptests/splinkersets01/splinkersets01.h	(revision 5fe6d07ad5690e3d9c6445ca3a465a700a5a5015)
@@ -30,7 +30,19 @@
 RTEMS_LINKER_ROSET_DECLARE(test_ro, const int *);
 
+RTEMS_LINKER_RWSET_DECLARE(test_content_rw, char);
+
+RTEMS_LINKER_ROSET_DECLARE(test_content_ro, char);
+
 RTEMS_LINKER_RWSET_ITEM_DECLARE(test_rw, const int *, a1);
 
 RTEMS_LINKER_ROSET_ITEM_DECLARE(test_ro, const int *, ca2);
+
+RTEMS_LINKER_RWSET_CONTENT(test_content_rw, extern int content_rw_1);
+RTEMS_LINKER_RWSET_CONTENT(test_content_rw, extern char content_rw_2);
+RTEMS_LINKER_RWSET_CONTENT(test_content_rw, extern char content_rw_3);
+
+RTEMS_LINKER_ROSET_CONTENT(test_content_ro, extern const int content_ro_1);
+RTEMS_LINKER_ROSET_CONTENT(test_content_ro, extern const char content_ro_2);
+RTEMS_LINKER_ROSET_CONTENT(test_content_ro, extern const char content_ro_3);
 
 #ifdef __cplusplus
